import router from "../router.mjs";
import { mimes, queries } from "./inc/index.mjs";
import sql from "../sql.mjs";

router.get(/^\/random(\/image|\/video|\/audio)?$/, async (req, res) => {
  const args = [];
  let q = queries.random.main;
  
  q += queries.random.where(mimes[req.url.split[1]] ? mimes[req.url.split[1]].map(mime => `mime = "${mime}"`).join(" or ") : null);

  try {
    const rows = await sql.query(q, args);
    res.redirect(`/${req.url.split[1] ? req.url.split[1] + "/" : ""}${rows[0].id}`);
  } catch(err) {
    res
      .writeHead(500)
      .end(JSON.stringify(err), "utf-8");
  }
});
